      subroutine frmbm(dist,bm,iorder,nom,nobm,nob,iab)
***********************************************************************
* Subroutine the form the basis function vector BM(nob) for given point
* nom:  	number of monomials
* nobm:         number of maximum basi functions
* nob:  	number of basis functions(polynomials)
* iab:          flag to indicate whether function a or function b is
*               used
* M(nom):	Array to store monomials
* P(nobm):	Array to store polynomials
***********************************************************************
      
      implicit double precision (a-h,o-z)

      common /inout/ icoord,ifmt,iout,isan
      common /optn/ iatyp,icop,imethd,iwop,ityp,nfun,imga,imgb,imgc,imgd

      integer i,j,k
      integer nom,nobm,nob,iab
      double precision dist(6)
C      double precision r(nop,6), bm(nop,nobm),V2b(nop)
      double precision bm(nobm)
      double precision,allocatable,dimension(:):: bm1, bm2, p

      allocate(p(0:nobm-1),bm1(nobm),bm2(nobm))

      do j=1,nobm
       p(j-1)=0.0d0
       bm(j)=0.0d0
       bm1(j)=0.0d0
       bm2(j)=0.0d0
      enddo

      call evbas(dist,p,iorder,nom,nobm,iab)
      if (imethd .eq. 0) then
        nob=nobm
        do j=1,nob
          bm(j)=p(j-1)
        enddo
      else if (imethd .eq. 1) then
        do j=1,nobm
          bm1(j)=p(j-1)
        enddo
        call frmbmxnc(bm1,bm2,iorder,nobm,nob)
        do j=1,nob
          bm(j)=bm2(j)
        enddo
      else if (imethd .eq. 2) then
C Evaluate basis matrix by removing 2-body terms from 
C Bowman-Braams' expansion (Xie and Bowman's approach)
        do j=1,nobm
          bm1(j)=p(j-1)
        enddo
        call frmbmx2b(bm1,bm2,iorder,nobm,nob)
        do j=1,nob
          bm(j)=bm2(j)
        enddo
      else if (imethd .eq. 3) then
C Evaluate basis matrix by removing 2-body and 3-body terms from 
C Bowman-Braams' expansion (Xie and Bowman's approach)
C removing 3-body terms is necessary for a 4 atoms system dissociated to
C 1+3 fragments. Now only available for AB3 system -YS
        do j=1,nobm
          bm1(j)=p(j-1)
        enddo
        call frmbmx3b(bm1,bm2,iorder,nobm,nob)
        do j=1,nob
          bm(j)=bm2(j)
        enddo
      endif

C close the old arrays, which no longer needed, to release memory -VZ
      deallocate(p,bm1,bm2)

      end 
