      subroutine readdat(R,Jacob,X,Vabit,Vcas,Vcor,nop,pairw,
     $                   ecor,ired,nred,esw) 
***********************************************************************
*  Program to calculate the XYZ coordinate by reading the data 
*
*  ICoord = 0   Internal (Jacob) coordinate
*         = 1   Cartesian coordinate
*
*  IFmt   = 0   The ab initio set does not include data index
*         = 1   The ab initio set includes data index
*
* Ecor  = 0     Vll and Vhl are fitted alogether
*       = 1     Vll and Vhl are fitted separately
*               but read from the same source file       
*       = 2     Only Vll is fitted
*       = 3     Only Vhl is fitted
*       = 4     Vll and Vhl are fitted separately
*               and read from different sources
* esw   = 0,1   switching for Ecor=4 
*  
*
***********************************************************************
      implicit double precision (a-h,o-z)

      common /inout/ icoord,ifmt,iout,isan
      common /optn/ iatyp,icop,imethd,iwop,ityp,nfun,imga,imgb,imgc,imgd
      common /energy/ ecr,esh,epow,elimit,erange(4),grange(4),v0

      character (len=50) uinp,abnu,outu,erru,cffu,vfu,vfeu,vfe2u,
     $                   abnucas,abnucor,vfcas,vfcor,cffucas,cffucor
      common /filnam/ uinp,abnu,outu,erru,cffu,vfu,vfeu,vfe2u,
     $                   abnucas,abnucor,vfcas,vfcor,cffucas,cffucor

      integer i,j,io,n
      integer indx,iout
      integer nop,noplim,nopcount
      integer esw
      integer pairw,ecor,ired,nred
      double precision Dist(6),V,Vca,Temp(12),XTemp(12)
      double precision Jacob(nop,6),R(nop,6),X(nop,12),
     $                 Vabit(nop),Vcor(nop),Vcas(nop)
      logical fe1,fe2,fe3,fe4
      character (len=100) record1,records

       if (ecor .ge. 2) then
         inquire(file=trim(adjustl(abnucas)),EXIST=fe1)
         inquire(file="main.abncas",EXIST=fe3)
         inquire(file=trim(adjustl(abnucor)),EXIST=fe2)
         inquire(file="main.abncor",EXIST=fe4)
        if (esw .eq. 0) then
         if (fe1 .EQV. .True.) then
          open (unit=20, file=abnucas)
         else
           if (fe3 .EQV. .True.) then
            open (unit=20, file="main.abnll")
           endif
         endif
        else if (esw .eq. 1) then
          if (fe2 .EQV. .True.) then
           open (unit=20, file=abnucor)
          else
            if (fe4 .EQV. .True.) then
             open (unit=20, file="main.abnhl")
            endif
          endif
        endif  ! ews
C Skip the first twenty lines
         do i=1,20
          read (20,*)
         enddo
       else if (ecor .lt. 2) then
C Then read ab initio data
        inquire(file=trim(adjustl(abnu)),EXIST=fe1)
         if (fe1 .EQV. .True.) then
          open (unit=20, file=abnu)
         else
          inquire(file="main.abn",EXIST=fe2)
           if (fe2 .EQV. .True.) then
            open (unit=20, file="main.abn")
           else
            stop
           endif
          continue
         endif
C Skip the first twenty lines
        do i=1,20
         read (20,*)
        enddo
       endif

C Print reduced set if ired = 1
      if (ired .eq. 1) then
        open(unit=21,file="main.abn.red")
      endif

C Beging to read the data for fitting
      noplim=nop+1
      nop=0
      nopcount=0
C Determine what coordinates will be read in
C Read Jocob coordinates
      if (ecor .ne. 1) then
       if (icoord .eq. 0) then
        do
          nopcount=nopcount + 1
          if (nopcount .eq. noplim) then
           goto 900
          endif
C Decide which format to be read KRY 12/07/2013
          if (ifmt .eq. 0) then
            read(20,*,IOSTAT=io) Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V
          else if (ifmt .eq. 1) then
            read(20,*,IOSTAT=io) indx,Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V
C Print reduced dataset by deleting every nred points
            if ((ired .eq. 1) .and. (mod(indx,nred) .ne. 0)) then
              write(21,3000) indx,Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V
            endif
 3000 Format(I10,7F15.7)
          endif
          if (io .GT. 0) then
            write(*,*) "There is something wrong with your input file!"
            write(*,*) "Please check it!"
            stop
          else if(io .LT. 0) then
C            write(*,*) "Reach the end of the input file."
            exit
          else if(V .LT. elimit) then
            nop=nop + 1
            call coordconvt(Temp,Dist,XTemp)
C        Store the internuclear distances in Matrix R(nop,6)
C        Store the abintio energies into Vabit(nop)
            do i=1,6
              R(nop,i)=Dist(i)
              Jacob(nop,i)=Temp(i)
            enddo
            do i=1,12
              X(nop,i)=Xtemp(i)
            enddo
            Vabit(nop)=V
          endif
        enddo
C Read Cartesian Coordinates
       else if (icoord .eq. 1) then
        do
          nopcount=nopcount+1
          if (nopcount .eq. noplim) then
           goto 900
          endif
C Read different format of data based on IFmt   KRY 12/07/2013
          if (ifmt .eq. 0) then
            read(20,*,IOSTAT=io) V
            read(20,*) Temp(1),Temp(2),Temp(3)
            read(20,*) Temp(4),Temp(5),Temp(6)
            read(20,*) Temp(7),Temp(8),Temp(9)
            read(20,*) Temp(10),Temp(11),Temp(12)
          else if (ifmt .eq. 1) then
            read(20,*,IOSTAT=io) indx,V
            read(20,*) Temp(1),Temp(2),Temp(3)
            read(20,*) Temp(4),Temp(5),Temp(6)
            read(20,*) Temp(7),Temp(8),Temp(9)
            read(20,*) Temp(10),Temp(11),Temp(12)
          endif
          if (io .GT. 0) then
            write(*,*) "There is something wrong with your input file!"
            write(*,*) "Please check it!"
            stop
          else if(io .LT. 0) then
C            write(*,*) "Reach the end of the input file."
            exit
          else if(io .EQ. 0) then
            if (V .LT. elimit) then
C Print reduced dataset by deleting every nred points
              if ((ired .eq. 1) .and. (mod(indx,nred) .ne. 0)) then
                write(21,3100) indx,V
                write(21,3200) Temp(1),Temp(2),Temp(3)
                write(21,3200) Temp(1),Temp(2),Temp(3)
                write(21,3200) Temp(1),Temp(2),Temp(3)
                write(21,3200) Temp(1),Temp(2),Temp(3)
              endif
 3100 Format(I6,F13.4)
 3200 Format(3F12.6)
              nop=nop + 1
              call coordconvt(Temp,Dist,XTemp)
C      Temporary store the internuclear distances in Matrix Rr(nop,6)
C      and the abintio energies in Vabitr(nop) -VZ
              do i=1,6
                R(nop,i)=Dist(i)
              enddo
              do i=1,12
                X(nop,i)=Temp(i)
              enddo
              Vabit(nop)=V
            endif
          endif
        enddo
      else if (icoord .eq. 2) then
        do
          nopcount=nopcount+1
          if (nopcount .eq. noplim) then
           goto 900
          endif
C Decide which format to be read KRY 12/07/2013
          if (ifmt .eq. 0) then
            read(20,*,IOSTAT=io) Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V
          else if (ifmt .eq. 1) then
            read(20,*,IOSTAT=io) indx,Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V
C Print reduced dataset by deleting every nred points
            if ((ired .eq. 1) .and. (mod(indx,nred) .ne. 0)) then
              write(21,3000) indx,Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V
            endif
C 3000 Format(I10,7F15.7)
          endif
          if (io .GT. 0) then
            write(*,*) "There is something wrong with your input file!"
            write(*,*) "Please check it!"
            stop
          else if(io .LT. 0) then
C            write(*,*) "Reach the end of the input file."
            exit
          else if(V .LT. elimit) then
            nop=nop + 1
C        Store the internuclear distances in Matrix R(nop,6)
C        Store the abintio energies into Vabit(nop)
            do i=1,6
              R(nop,i)=Temp(i)
            enddo
            Vabit(nop)=V
          endif
        enddo
      endif

      else if (ecor .eq. 1) then
      if (icoord .eq. 0) then
        do
          nopcount=nopcount+1
          if (nopcount .eq. noplim) then
           goto 900
          endif
C Decide which format to be read KRY 12/07/2013
          if (ifmt .eq. 0) then
            read(20,*,IOSTAT=io) Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V,Vca
          else if (ifmt .eq. 1) then
            read(20,*,IOSTAT=io) indx,Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V,Vca
C Print reduced dataset by deleting every nred points
            if ((ired .eq. 1) .and. (mod(indx,nred) .ne. 0)) then
              write(21,3000) indx,Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V,Vca
            endif
          endif
          if (io .GT. 0) then
            write(*,*) "There is something wrong with your input file!"
            write(*,*) "Please check it!"
            stop
          else if(io .LT. 0) then
C            write(*,*) "Reach the end of the input file."
            exit
          else if(V .LT. elimit) then
            nop=nop + 1
            call coordconvt(Temp,Dist,XTemp)
C        Store the internuclear distances in Matrix R(nop,6)
C        Store the abintio energies into Vabit(nop)
            do i=1,6
              R(nop,i)=Dist(i)
              Jacob(nop,i)=Temp(i)
            enddo
            do i=1,12
              X(nop,i)=Xtemp(i)
            enddo
            Vabit(nop)=V
            Vcas(nop)=Vca
            Vcor(nop)=V-Vca
          endif
        enddo
C Read Cartesian Coordinates
      else if (icoord .eq. 1) then
        do
          nopcount=nopcount+1
          if (nopcount .eq. noplim) then
           goto 900
          endif
C Read different format of data based on IFmt   KRY 12/07/2013
          if (ifmt .eq. 0) then
            read(20,*,IOSTAT=io) V,Vca
            read(20,*) Temp(1),Temp(2),Temp(3)
            read(20,*) Temp(4),Temp(5),Temp(6)
            read(20,*) Temp(7),Temp(8),Temp(9)
            read(20,*) Temp(10),Temp(11),Temp(12)
          else if (ifmt .eq. 1) then
            read(20,*,IOSTAT=io) indx,V,Vca
            read(20,*) Temp(1),Temp(2),Temp(3)
            read(20,*) Temp(4),Temp(5),Temp(6)
            read(20,*) Temp(7),Temp(8),Temp(9)
            read(20,*) Temp(10),Temp(11),Temp(12)
          endif
          if (io .GT. 0) then
            write(*,*) "There is something wrong with your input file!"
            write(*,*) "Please check it!"
            stop
          else if(io .LT. 0) then
C            write(*,*) "Reach the end of the input file."
            exit
          else if(io .EQ. 0) then
            if(V .LT. elimit) then
C Print reduced dataset by deleting every nred points
              if ((ired .eq. 1) .and. (mod(indx,nred) .ne. 0)) then
                write(21,3100) indx,V,Vca
                write(21,3200) Temp(1),Temp(2),Temp(3)
                write(21,3200) Temp(1),Temp(2),Temp(3)
                write(21,3200) Temp(1),Temp(2),Temp(3)
                write(21,3200) Temp(1),Temp(2),Temp(3)
              endif
              nop=nop + 1
              call coordconvt(Temp,Dist,XTemp)
C      Temporary store the internuclear distances in Matrix Rr(nop,6)
C      and the abintio energies in Vabitr(nop) -VZ
              do i=1,6
                R(nop,i)=Dist(i)
              enddo
              do i=1,12
                X(nop,i)=Temp(i)
              enddo
              Vabit(nop)=V
              Vcas(nop)=Vca
              Vcor(nop)=V-Vca
            endif
          endif
        enddo
       else if (iccord .eq. 2) then
        do
          nopcount=nopcount+1
          if (nopcount .lt. noplim) then
           goto 900
          endif

C Decide which format to be read KRY 12/07/2013
          if (ifmt .eq. 0) then
            read(20,*,IOSTAT=io) Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V,Vca
          else if (ifmt .eq. 1) then
            read(20,*,IOSTAT=io) indx,Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V
C Print reduced dataset by deleting every nred points
            if ((ired .eq. 1) .and. (mod(indx,nred) .ne. 0)) then
              write(21,3000) indx,Temp(1),Temp(2),Temp(3),Temp(4),
     $                         Temp(5),Temp(6),V,Vca
            endif
          endif
          if (io .GT. 0) then
            write(*,*) "There is something wrong with your input file!"
            write(*,*) "Please check it!"
            stop
          else if(io .LT. 0) then
C            write(*,*) "Reach the end of the input file."
            exit
          else if(V .LT. elimit) then
            nop=nop + 1
C        Store the internuclear distances in Matrix R(nop,6)
C        Store the abintio energies into Vabit(nop)
            do i=1,6
              R(nop,i)=Temp(i)
            enddo
            Vabit(nop)=V
              Vcas(nop)=Vca
              Vcor(nop)=V-Vca
          endif
        enddo
      endif
      endif

      if (ired .eq. 1) then
        close(21)
        write(30,3300) "Reduced data set is generated by deleting
     $ every",nred,"th data points"
        stop
      endif

 900  continue

 3300 Format(A,I3,A)

      end
