      subroutine calrmsd(a,b,c,nop,nops,rmsd,sd,mud)
***********************************************************************
* Little subroutine to calculate RMSDs of two arrays 
* for different energy ranges 
* a:		Vabit(nop*1)
* b:		Vfit(nop*1)
* rmsd:		Array to store RMSDs of different energy ranges
* rmsd(1):	RMSD for Vabit<erange(1) kcal/mol    -VZ
* rmsd(2):      RMSD for erange(1)<=Vabit<eerange(2) kcal/mol    -VZ
* rmsd(3):      RMSD for erange(2)<=Vabit<erange(3) kcal/mol    -VZ
* rmsd(4):      RMSD for erange(3)<=Vabit<erange(4) kcal/mol    -VZ
* rmsd(5):      RMSD for Vabit>=erange(4) kcal/mol    -VZ
* rmsd(6):	RMSD for whole energy range
*
***********************************************************************
      implicit double precision (a-h,o-z)

      integer i,nop
      integer nops(6)
      double precision c(4),rmsd(6),sd(6)
      double precision mud(6),ud(6)

      double precision a(nop), b(nop)
 
      do i=1,6
        nops(i)=0
        rmsd(i)=0.0d0
        mud(i)=0.0d0
        sd(i)=0.0d0
        ud(i)=0.0d0
      enddo  
C
C0426 Calculate the squared deviation according to Vabit(i)
C

      do i=1,nop
        if (a(i) .lt. c(1)) then
          nops(1)=nops(1)+1
          sd(1)=sd(1) + (a(i) - b(i))*(a(i) - b(i))
          ud(1)=ud(1) + abs(a(i) - b(i))
        else if(a(i) .lt. c(2)) then
          nops(2)=nops(2)+1
          sd(2)=sd(2) + (a(i) - b(i))*(a(i) - b(i))
          ud(2)=ud(2) + abs(a(i) - b(i))
        else if(a(i) .lt. c(3)) then
          nops(3)=nops(3)+1
          sd(3)=sd(3) + (a(i) - b(i))*(a(i) - b(i))
          ud(3)=ud(3) + abs(a(i) - b(i))
        else if(a(i) .lt. c(4)) then
          nops(4)=nops(4)+1
          sd(4)=sd(4) + (a(i) - b(i))*(a(i) - b(i))
          ud(4)=ud(4) + abs(a(i) - b(i))
        else 
          nops(5)=nops(5)+1
          sd(5)=sd(5) + (a(i) - b(i))*(a(i) - b(i))
          ud(5)=ud(5) + abs(a(i) - b(i))
        end if 
      enddo
C
C0426 Calculate and print the RMSDs for different energy ranges
C

      do i=1,5
C        print *, 'nops',i,'=',nops(i)
        rmsd(i)=sqrt(sd(i)/nops(i))
C        write(*,9994)i,nops(i),i,rmsd(i) 
C 9994 Format(' NOPs',I1,' = ',I6,' RMSD for energy range',I2,' is',
C     $ F10.2,' kcal/mol')
      enddo  

C
C0426 Calcualte and print the RMSDs for thw whole energy range
C
      sd(6)=sd(1) + sd(2) + sd(3) + sd(4) + sd(5)
      ud(6)=ud(1) + ud(2) + ud(3) + ud(4) + ud(5)
      nops(6)=nops(1) + nops(2) + nops(3) + nops(4) + nops(5)
      rmsd(6)=sqrt(sd(6)/nops(6))
C      mud(6)=ud(6)/nops(6)
C      write(*,9994) 6,nops(6),6,rmsd(6)
C      write(*,*) 'Squared deviation',sd(6) 

      do i=1,6
        mud(i)=ud(i)/nops(i)
C        write(*,9993) i,nops(i),i,mud(i)
      enddo
C 9993 Format(' NOPs',I1,' = ',I6,'  MUD for energy range',I2,' is',
C     $ F10.2,' kcal/mol')
C
C0422 Now calculate RMSDs and MUDs for N2+N2 scans
C
C      do i=1,6
C        nops(i)=0
C        rmsd(i)=0.0d0
C        mud(i)=0.0d0
C        sd(i)=0.0d0
C        ud(i)=0.0d0
C      enddo
C
C0422 Calculate the squared deviation according to Vabit(i)
C
C
C      do i=1,15363
C        if (a(i) .lt. c(1)) then
C          nops(1)=nops(1)+1
C          sd(1)=sd(1) + (a(i) - b(i))*(a(i) - b(i))
C          ud(1)=ud(1) + abs(a(i) - b(i))
C        else if(a(i) .lt. c(2)) then
C          nops(2)=nops(2)+1
C          sd(2)=sd(2) + (a(i) - b(i))*(a(i) - b(i))
C          ud(2)=ud(2) + abs(a(i) - b(i))
C        else if(a(i) .lt. c(3)) then
C          nops(3)=nops(3)+1
C          sd(3)=sd(3) + (a(i) - b(i))*(a(i) - b(i))
C          ud(3)=ud(3) + abs(a(i) - b(i))
C        else if(a(i) .lt. c(4)) then
C          nops(4)=nops(4)+1
C          sd(4)=sd(4) + (a(i) - b(i))*(a(i) - b(i))
C          ud(4)=ud(4) + abs(a(i) - b(i))
C        else
C          nops(5)=nops(5)+1
C          sd(5)=sd(5) + (a(i) - b(i))*(a(i) - b(i))
C          ud(5)=ud(5) + abs(a(i) - b(i))
C        end if
C      enddo

C
C0422 Calculate and print the RMSDs for different energy ranges
C
C      write(*,*) ' For N2+N2 range'
C      write(*,9999) c(1)
C      write(*,9998) c(1),c(2)
C      write(*,9997) c(2),c(3)
C      write(*,9996) c(3),c(4)
C      write(*,9995) c(4)

C
C0422 Calcualte and print the RMSDs for thw whole energy range
C
C      sd(6)=sd(1) + sd(2) + sd(3) + sd(4) + sd(5)
C      ud(6)=ud(1) + ud(2) + ud(3) + ud(4) + ud(5)
C      nops(6)=nops(1) + nops(2) + nops(3) + nops(4) + nops(5)
C      rmsd(6)=sqrt(sd(6)/nops(6))
C      mud(6)=ud(6)/nops(6)
C      write(*,9994) 6,nops(6),6,rmsd(6)
C      write(*,*) 'Squared deviation',sd(6)

C      do i=1,6
C        mud(i)=ud(i)/nops(i)
C        write(*,9993) i,nops(i),i,mud(i)
C      enddo
 
      return
      end


      subroutine calrmsd_geom(a,b,c,d,nop,nops,rmsd,sd,mud)
***********************************************************************
* Little subroutine to calculate RMSDs of two arrays
* for different energy ranges
* a:            Vabit(nop*1)
* b:            Vfit(nop*1)
* c:            Boundaries for geometry ranges
* d:            Internuclear distances
* rmsd:         Array to store RMSDs of different energy ranges
* rmsd(1):      RMSD for geom > grange(1) Ang    -VZ
* rmsd(2):      RMSD for grange(1)<=geom<grange(2) Ang    -VZ
* rmsd(3):      RMSD for grange(2)<=geom<grange(3) Ang    -VZ
* rmsd(4):      RMSD for grange(3)<=geom<grange(4) Ang    -VZ
* rmsd(5):      RMSD for geom >=grange(4) kcal/mol    -VZ
* rmsd(6):      RMSD for whole geom range
*
***********************************************************************
      implicit double precision (a-h,o-z)

      integer i,nop
      integer nops(6)
      double precision c(4),rmsd(6),sd(6)
      double precision mud(6),ud(6)

      double precision a(nop), b(nop),d(nop,6),e(nop)

      do i=1,6
        nops(i)=0
        rmsd(i)=0.0d0
        mud(i)=0.0d0
        sd(i)=0.0d0
        ud(i)=0.0d0
      enddo
C
C0426 Calculate the squared deviation according to Vabit(i)
C

      do i=1,nop
        e(i)=(d(i,1)+d(i,2)+d(i,3)+d(i,4)+d(i,5)+d(i,6))/6.0d0

        if (e(i) .lt. c(1)) then
          nops(1)=nops(1)+1
          sd(1)=sd(1) + (a(i) - b(i))*(a(i) - b(i))
          ud(1)=ud(1) + abs(a(i) - b(i))
        else if(e(i) .lt. c(2)) then
          nops(2)=nops(2)+1
          sd(2)=sd(2) + (a(i) - b(i))*(a(i) - b(i))
          ud(2)=ud(2) + abs(a(i) - b(i))
        else if(e(i) .lt. c(3)) then
          nops(3)=nops(3)+1
          sd(3)=sd(3) + (a(i) - b(i))*(a(i) - b(i))
          ud(3)=ud(3) + abs(a(i) - b(i))
        else if(e(i) .lt. c(4)) then
          nops(4)=nops(4)+1
          sd(4)=sd(4) + (a(i) - b(i))*(a(i) - b(i))
          ud(4)=ud(4) + abs(a(i) - b(i))
        else
          nops(5)=nops(5)+1
          sd(5)=sd(5) + (a(i) - b(i))*(a(i) - b(i))
          ud(5)=ud(5) + abs(a(i) - b(i))
        end if
      enddo
C
C0426 Calculate and print the RMSDs for different energy ranges
C

      do i=1,5
C        print *, 'nops',i,'=',nops(i)
        rmsd(i)=sqrt(sd(i)/nops(i))
C        write(*,9994)i,nops(i),i,rmsd(i)
C 9994 Format(' NOPs',I1,' = ',I6,' RMSD for energy range',I2,' is',
C     $ F10.2,' kcal/mol')
      enddo

C
C0426 Calcualte and print the RMSDs for thw whole energy range
C
      sd(6)=sd(1) + sd(2) + sd(3) + sd(4) + sd(5)
      ud(6)=ud(1) + ud(2) + ud(3) + ud(4) + ud(5)
      nops(6)=nops(1) + nops(2) + nops(3) + nops(4) + nops(5)
      rmsd(6)=sqrt(sd(6)/nops(6))
C      mud(6)=ud(6)/nops(6)
C      write(*,9994) 6,nops(6),6,rmsd(6)
C      write(*,*) 'Squared deviation',sd(6)

      do i=1,6
        mud(i)=ud(i)/nops(i)
C        write(*,9993) i,nops(i),i,mud(i)
      enddo

      return
      end


