      subroutine detcoef(BM,Vabit,C,V2b,rcond,nop,nobm,nob,d)
***********************************************************************
* Subroutine the form the basis function matrix BM(nop,nob)
* BM(nop,nob)*Ca(nob)=V(nop)
* Cp(nob1):          Coefficient matrix from Call_DGELS	
* C(nob):            Coefficients in the final fitting
***********************************************************************
      
      implicit double precision (a-h,o-z)

      common /energy/ ecr,esh,epow,elimit,erange(4),grange(4),v0
      common /optn/ iatyp,icop,imethd,iwop,ityp,nfun,imga,imgb,imgc,imgd

      integer i,j,k,nob1,nob2
      double precision ecr,esh,v0
      double precision rcond
      double precision v2b(nop),vabit(nop)
      double precision bm(nop,nobm),c(nobm)
      double precision,allocatable,dimension(:):: cp, vp
      double precision,allocatable,dimension(:,:):: bmp

      double precision,dimension(:):: d(nop)

      allocate(cp(nobm),vp(nobm))
      allocate(bmp(nobm,nobm))
      do i=1,nobm
        do j=1,nobm
          bmp(i,j)=0.0d0
        enddo
        cp(i)=0.0d0
        vp(i)=0.0d0
      enddo
      nob1=0
C
C Preparing normal equation by call FrmBMp
C
      call frmbmp(bm,bmp,vabit,vp,v2b,nop,nobm,nob,nob1,d)
      write(*,*) "Succeed to call FrmBMp to obtain normal equation."
C
C Call DGELSD in LAPACK to solve BM'*C'=V'
C

      write(*,*) "Call DGELSD to solve normal equation."
      call call_dgelsd(bmp,vp,cp,rcond,nobm,nob1)
      write(*,*) "Succeed to solve normal equation."
C
C Restore Coefficient matrix C(nob) based on icop option
C
C Without using constraints
      if (icop .eq. 0) then
        do i=1,nob1
          c(i)=cp(i)
        enddo
C Constraint C(1)=V0
C revised and simplified - VZ 050114
      else if(icop .eq. 1) then
        c(1)=v0
        do i=1,nob1
          c(i)=cp(i+1)
        enddo
C          do i=1,noba
C           c(i+1)=cp(i)
C          enddo
C        c(noba+2)=0.0D0
C          do i=noba+1,nob
C           c(i+2)=cp(i)
C          enddo
C Print error information
      else
        write(30,*) "Only 0 or 1 is allowed for icop!"  
        stop
      endif

C close the old arrays, which no longer needed, to release memory -VZ
      deallocate(cp,vp,bmp)

      end 
