      subroutine ev2b(dist,v,V2ABx,V2ACx,V2ADx,V2BCx,V2BDx,V2CDx,pairw
     $               ,disp) 
***********************************************************************
* Program to read r and calculated potential energy of N2 
***********************************************************************
      
      implicit double precision (a-h,o-z) 

C      common /optn/ iatyp,icoord,icop,imethd,iwop,ityp,iorder,nfun,ctr
C      common /size/ nob,nom,nop,nopb,nobm,nopm
      common /optn/ iatyp,icop,imethd,iwop,ityp,nfun,imga,imgb,imgc,imgd
      integer pairw

      integer i,nop
      double precision rn2,vn2,rno,vno,ro2,vo2
      double precision dist(6),dv2dr(6),v,v2 
C keep the diatomic energies  -VZ
      double precision V2ABx,V2ACx,V2ADx,V2BCx,V2BDx,V2CDx
      double precision disp, dispdr

C N4 PES with Yuliya's dataset
      if (iatyp .eq. 56) then
        v=0.0d0
        do i=1,6
          r=dist(i)
C Call N2 PEC with out SEC, De = 228.7 kcal/mol 
C         call ev2gm2(r,v2,dv2dr,pairw,1,0)
!!!! to get the same PWs for all the surfaces !!!!
C Call N2 PEC with SEC, De = 228.4 kcal/mol
          call ev2gm2(r,v2,dv2dr,pairw,2,0)
!         write(*,*) "v_pw ",v2
          v=v+v2
! list diatomic energies into the file vfit_ext -VZ
      if      (i .eq. 1) then
       V2ABx=v2
      else if (i .eq. 2) then
       V2ACx=v2
      else if (i .eq. 3) then
       V2ADx=v2
      else if (i .eq. 4) then
       V2BCx=v2
      else if (i .eq. 5) then
       V2BDx=v2
      else if (i .eq. 6) then
       V2CDx=v2
      endif

        enddo
C v = 0.0 for infinite separated 4N, so 2De needs to added back.
C       v=v+457.4d0
!!!! to get the same PWs for all the surfaces !!!!
        v=v+456.8d0

C O4 PES with Ke's future results
      else if (iatyp .eq. 64) then
        v=0.0d0
        do i=1,6
          r=dist(i)
C Call O2 PEC, De = 120.243 kcal/mol
          call ev2gm2(r,v2,dv2dr,pairw,4,0)
          v=v+v2
! list diatomic energies into the file vfit_ext -VZ
      if      (i .eq. 1) then
       V2ABx=v2
      else if (i .eq. 2) then
       V2ACx=v2
      else if (i .eq. 3) then
       V2ADx=v2
      else if (i .eq. 4) then
       V2BCx=v2
      else if (i .eq. 5) then
       V2BDx=v2
      else if (i .eq. 6) then
       V2CDx=v2
      endif

        enddo
C v = 0.0 for infinite separated 4O, so 2De needs to added back. 
        v=v+240.486d0

C N2O2 PES with Zoltan's dataset
      else if (iatyp .eq. 60) then
        v=0.0d0
C r1 = rOO, call O2 PEC with SEC, De = 120.243 kcal/mol
        r=dist(1)
        call ev2gm2(r,v2,dv2dr,pairw,4,0)        
        v=v+v2
! diatomic OO energy to the file vfit_ext -VZ
        v2ABx=v2
!C r2, r3, r4, r5 are rNO, call NO PEC with SEC, De = 149.9 kcal/mol
!--old
! modified by ZV 3/3/14
C r2, r3, r4, r5 are rNO, call NO PEC with SEC, De = 152.6 kcal/mol
        do i=2,5
          r=dist(i)
          call ev2gm2(r,v2,dv2dr,pairw,3,0)
          v=v+v2
! each diatomic NO energy to the file vfit_ext -VZ
      if      (i .eq. 2) then
       V2ACx=v2
      else if (i .eq. 3) then
       V2ADx=v2
      else if (i .eq. 4) then
       V2BCx=v2
      else if (i .eq. 5) then
       V2BDx=v2
      endif
        enddo
C r6 = rNN, call N2 PEC with SEC, De = 228.4 kcal/mol
        r=dist(6)
        call ev2gm2(r,v2,dv2dr,pairw,2,0)
        v=v+v2
! diatomic NN energy to the file vfit_ext -VZ
        v2CDx=v2
C v = 0.0 for infinite separated 2O + 2N, so De(N2)+De(O2) needs to added back.
        v=v+348.643d0
      else
        write(*,*) "Only N4 (IATyp = 56), N2O2 (IATyp = 60),"
        write(*,*) "O4 (IATyp = 60) are allowed with ICop = 2!"
        stop
      endif

C calculate D3 dispersion and add that to the two-body terms
C it is also taken into account when ev2bcor - ev2bcas is calculated
C due to subroutine ev2bcor

      disp = 0.0d0
      if(pairw .eq. 3) then
      call d3disp(dist,disp,dispdr,0)
      v=v+disp
      endif

      end

      subroutine ev2bcas(dist,v,V2ABx,V2ACx,V2ADx,V2BCx,V2BDx,V2CDx,
     $                   pairw)
************************************************************************
* Program to read r and calculated CASSCF potential energy for diatomics
************************************************************************

      implicit double precision (a-h,o-z)

      common /optn/ iatyp,icop,imethd,iwop,ityp,nfun,imga,imgb,imgc,imgd
      integer pairw

      integer i,nop
      double precision rn2,vn2,rno,vno,ro2,vo2
      double precision dist(6),dv2dr(6),v,v2
C keep the diatomic energies  -VZ
      double precision V2ABx,V2ACx,V2ADx,V2BCx,V2BDx,V2CDx

C N4 PES with Yuliya's dataset
      if (iatyp .eq. 56) then
        v=0.0d0
        do i=1,6
          r=dist(i)
C Call N2 PEC with out SEC, De = 228.7 kcal/mol
          call ev2gm2cas(r,v2,dv2dr,pairw,1,0)
          v=v+v2
! list diatomic energies into the file vfit_ext -VZ
      if      (i .eq. 1) then
       V2ABx=v2
      else if (i .eq. 2) then
       V2ACx=v2
      else if (i .eq. 3) then
       V2ADx=v2
      else if (i .eq. 4) then
       V2BCx=v2
      else if (i .eq. 5) then
       V2BDx=v2
      else if (i .eq. 6) then
       V2CDx=v2
      endif

        enddo
C v = 0.0 for infinite separated 4N, so 2De needs to added back.
        v=v+408.14d0

C O4 PES with Ke's future results
      else if (iatyp .eq. 64) then
        v=0.0d0
        do i=1,6
          r=dist(i)
C Call O2 PEC with SEC, De = 120.243 kcal/mol
          call ev2gm2cas(r,v2,dv2dr,pairw,4,0)
          v=v+v2
! list diatomic energies into the file vfit_ext -VZ
      if      (i .eq. 1) then
       V2ABx=v2
      else if (i .eq. 2) then
       V2ACx=v2
      else if (i .eq. 3) then
       V2ADx=v2
      else if (i .eq. 4) then
       V2BCx=v2
      else if (i .eq. 5) then
       V2BDx=v2
      else if (i .eq. 6) then
       V2CDx=v2
      endif

        enddo
C v = 0.0 for infinite separated 4O, so 2De needs to added back.
        v=v+178.92d0

C N2O2 PES with Zoltan's dataset
      else if (iatyp .eq. 60) then
        v=0.0d0
C r1 = rOO, call O2 PEC with SEC, De = 120.243 kcal/mol
        r=dist(1)
        call ev2gm2cas(r,v2,dv2dr,pairw,4,0)
        v=v+v2
! diatomic OO energy to the file vfit_ext -VZ
        v2ABx=v2
!C r2, r3, r4, r5 are rNO, call NO PEC with SEC, De = 149.9 kcal/mol
!--old
! modified by ZV 3/3/14
C r2, r3, r4, r5 are rNO, call NO PEC with SEC, De = 152.6 kcal/mol
        do i=2,5
          r=dist(i)
          call ev2gm2cas(r,v2,dv2dr,pairw,3,0)
          v=v+v2
! each diatomic NO energy to the file vfit_ext -VZ
      if      (i .eq. 2) then
       V2ACx=v2
      else if (i .eq. 3) then
       V2ADx=v2
      else if (i .eq. 4) then
       V2BCx=v2
      else if (i .eq. 5) then
       V2BDx=v2
      endif
        enddo
C r6 = rNN, call N2 PEC with SEC, De = 228.4 kcal/mol
        r=dist(6)
        call ev2gm2cas(r,v2,dv2dr,pairw,2,0)
        v=v+v2
! diatomic NN energy to the file vfit_ext -VZ
        v2CDx=v2
C v = 0.0 for infinite separated 2O + 2N, so De(N2)+De(O2) needs to
C added back.
        v=v+293.53d0
      else
        write(*,*) "Only N4 (IATyp = 56), N2O2 (IATyp = 60),"
        write(*,*) "O4 (IATyp = 60) are allowed with ICop = 2!"
        stop
      endif

      end

      subroutine ev2bcor(dist,v,V2ABx,V2ACx,V2ADx,V2BCx,V2BDx,V2CDx,
     $                   pairw,disp)
************************************************************************
* Program to read r and calculated CASSCF potential energy for diatomics
************************************************************************

      implicit double precision (a-h,o-z)

      common /optn/ iatyp,icop,imethd,iwop,ityp,nfun,imga,imgb,imgc,imgd
      integer pairw

      integer i,nop
      double precision rn2,vn2,rno,vno,ro2,vo2
      double precision dist(6),dv2dr(6),v,v2,vx,vy
C keep the diatomic energies  -VZ
      double precision V2ABx,V2ACx,V2ADx,V2BCx,V2BDx,V2CDx
      double precision V2ABy,V2ACy,V2ADy,V2BCy,V2BDy,V2CDy
      double precision disp

      call ev2b(dist,vx,V2ABx,V2ACx,V2ADx,V2BCx,V2BDx,V2CDx,pairw,disp)
      call ev2bcas(dist,vy,V2ABy,V2ACy,V2ADy,V2BCy,V2BDy,V2CDy,pairw)

      v=vx-vy
      V2ABx=V2ABx-V2ABy
      V2ACx=V2ACx-V2ACy
      V2ADx=V2ADx-V2ADy
      V2BCx=V2BCx-V2BCy
      V2BDx=V2BDx-V2BDy
      V2CDx=V2CDx-V2CDy

      end


