      subroutine evbas(dist,p,iorder,nom,nob,iab)
***********************************************************************
*  The subroutine reads six Morse variables(X), calculates the
*  monomials(M) that do not have usable decomposition, and then
*  calculate permutationally invariant polynomials (P)
***********************************************************************

      implicit double precision (a-h,o-z)

      common /optn/ iatyp,icop,imethd,iwop,ityp,nfun,imga,imgb,imgc,imgd
C      common /inout/ icoord,ifmt,iout,isan

      integer i,iab
      double precision dist(6)
      double precision rms(6),rm(0:nom-1),p(0:nob-1)

      do i=0,nom-1
       rm(i)=0.0d0
      enddo

C Evaluate six Morse terms: rMs(6)
C or evaluate six Gauss terms: rMs(6) -VZ 043014
C New funtion was added by IMG=4 option -VZ 060314
      call evms(dist,rms,iab)
C      write(*,*) "Succeed to call evms"
C      write(*,*) "iab = ",iab
C      do i=1,6
C        write(*,'(a,I1,a,F12.5)') 'RMS(',i,') = ',rms(i)
C      enddo

C Now evaluate Polynomial terms based on the system(ityp) and polynomial order(iorder)
C A4 system
C argument list of evpoly was changed  - VZ 043014
C argument lists of evmono and evpoly were changed - KRY 071714
      if (ityp .eq. 1) then
        if (iorder .eq. 5) then
          call evmono105(rms,rm,nom)
          call evpoly105(rm,p,nom,nob)
        else if(iorder .eq. 6) then
          call evmono106(rms,rm,nom)
          call evpoly106(rm,p,nom,nob)
        else if(iorder .eq. 7) then
          call evmono107(rms,rm,nom)
          call evpoly107(rm,p,nom,nob)
        else if(iorder .eq. 8) then
          call evmono108(rms,rm,nom)
          call evpoly108(rm,p,nom,nob)
        else if(iorder .eq. 9) then
          call evmono109(rms,rm,nom)
          call evpoly109(rm,p,nom,nob)
        else if(iorder .eq. 10) then
          call evmono110(rms,rm,nom)
          call evpoly110(rm,p,nom,nob)
        else if(iorder .eq. 11) then
          call evmono111(rms,rm,nom)
          call evpoly111(rm,p,nom,nob)
        else if(iorder .eq. 12) then
          call evmono112(rms,rm,nom)
          call evpoly112(rm,p,nom,nob)
        else if(iorder .eq. 0) then
          continue
        else
          write(*,*) "Incorrect order of polynomials!"
          stop
        endif
C A3B system -YS 060118
      else if(ityp .eq. 2) then
        if (iorder .eq. 5) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
        else if(iorder .eq. 6) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
        else if(iorder .eq. 7) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
          call evpoly207(rm,p,nom,nob)
        else if(iorder .eq. 8) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
          call evpoly207(rm,p,nom,nob)
          call evpoly208(rm,p,nom,nob)
        else if(iorder .eq. 9) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
          call evpoly207(rm,p,nom,nob)
          call evpoly208(rm,p,nom,nob)
          call evpoly209(rm,p,nom,nob)
        else if(iorder .eq. 10) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
          call evpoly207(rm,p,nom,nob)
          call evpoly208(rm,p,nom,nob)
          call evpoly209(rm,p,nom,nob)
          call evpoly210(rm,p,nom,nob)
        else if(iorder .eq. 11) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
          call evpoly207(rm,p,nom,nob)
          call evpoly208(rm,p,nom,nob)
          call evpoly209(rm,p,nom,nob)
          call evpoly210(rm,p,nom,nob)
          call evpoly211(rm,p,nom,nob)
        else if(iorder .eq. 12) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
          call evpoly207(rm,p,nom,nob)
          call evpoly208(rm,p,nom,nob)
          call evpoly209(rm,p,nom,nob)
          call evpoly210(rm,p,nom,nob)
          call evpoly211(rm,p,nom,nob)
          call evpoly212(rm,p,nom,nob)
        else if(iorder .eq. 13) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
          call evpoly207(rm,p,nom,nob)
          call evpoly208(rm,p,nom,nob)
          call evpoly209(rm,p,nom,nob)
          call evpoly210(rm,p,nom,nob)
          call evpoly211(rm,p,nom,nob)
          call evpoly212(rm,p,nom,nob)
          call evpoly213(rm,p,nom,nob)
        else if(iorder .eq. 14) then
          call evmono2(rms,rm,nom)
          call evpoly205(rm,p,nom,nob)
          call evpoly206(rm,p,nom,nob)
          call evpoly207(rm,p,nom,nob)
          call evpoly208(rm,p,nom,nob)
          call evpoly209(rm,p,nom,nob)
          call evpoly210(rm,p,nom,nob)
          call evpoly211(rm,p,nom,nob)
          call evpoly212(rm,p,nom,nob)
          call evpoly213(rm,p,nom,nob)
          call evpoly214(rm,p,nom,nob)
        else if(iorder .eq. 0) then
          continue
        else
          write(*,*) "Incorrect order of polynomials!"
          stop
        endif
C A2B2 system
      else if(ityp .eq. 3) then
        if (iorder .eq. 5) then
          call evmono3(rms,rm,nom)
          call evpoly305(rm,p,nom,nob)
        else if(iorder .eq. 6) then
          call evmono3(rms,rm,nom)
          call evpoly305(rm,p,nom,nob)
          call evpoly306(rm,p,nom,nob)
        else if(iorder .eq. 7) then
          call evmono3(rms,rm,nom)
          call evpoly305(rm,p,nom,nob)
          call evpoly306(rm,p,nom,nob)
          call evpoly307(rm,p,nom,nob)
        else if(iorder .eq. 8) then
          call evmono3(rms,rm,nom)
          call evpoly305(rm,p,nom,nob)
          call evpoly306(rm,p,nom,nob)
          call evpoly307(rm,p,nom,nob)
          call evpoly308(rm,p,nom,nob)
        else if(iorder .eq. 9) then
          call evmono3(rms,rm,nom)
          call evpoly305(rm,p,nom,nob)
          call evpoly306(rm,p,nom,nob)
          call evpoly307(rm,p,nom,nob)
          call evpoly308(rm,p,nom,nob)
          call evpoly309(rm,p,nom,nob)
        else if(iorder .eq. 10) then
          call evmono3(rms,rm,nom)
          call evpoly305(rm,p,nom,nob)
          call evpoly306(rm,p,nom,nob)
          call evpoly307(rm,p,nom,nob)
          call evpoly308(rm,p,nom,nob)
          call evpoly309(rm,p,nom,nob)
          call evpoly310(rm,p,nom,nob)
        else if(iorder .eq. 11) then
          call evmono3(rms,rm,nom)
          call evpoly305(rm,p,nom,nob)
          call evpoly306(rm,p,nom,nob)
          call evpoly307(rm,p,nom,nob)
          call evpoly308(rm,p,nom,nob)
          call evpoly309(rm,p,nom,nob)
          call evpoly310(rm,p,nom,nob)
          call evpoly311(rm,p,nom,nob)
        else if(iorder .eq. 12) then
          call evmono3(rms,rm,nom)
          call evpoly305(rm,p,nom,nob)
          call evpoly306(rm,p,nom,nob)
          call evpoly307(rm,p,nom,nob)
          call evpoly308(rm,p,nom,nob)
          call evpoly309(rm,p,nom,nob)
          call evpoly310(rm,p,nom,nob)
          call evpoly311(rm,p,nom,nob)
          call evpoly312(rm,p,nom,nob)
        else if(iorder .eq. 0) then
          continue
        else
          write(*,*) "Incorrect order of polynomials!"
          stop
        endif
C A2BC system
       else if(ityp .eq. 4) then
         if (iorder .eq. 5) then
           call evmono4(rms,rm,nom)
           call evpoly405(rm,p,nom,nob)
         else if(iorder .eq. 6) then
           call evmono4(rms,rm,nom)
           call evpoly405(rm,p,nom,nob)
           call evpoly406(rm,p,nom,nob)
         else if(iorder .eq. 7) then
           call evmono4(rms,rm,nom)
           call evpoly405(rm,p,nom,nob)
           call evpoly406(rm,p,nom,nob)
           call evpoly407(rm,p,nom,nob)
         else if(iorder .eq. 8) then
           call evmono4(rms,rm,nom)
           call evpoly405(rm,p,nom,nob)
           call evpoly406(rm,p,nom,nob)
           call evpoly407(rm,p,nom,nob)
           call evpoly408(rm,p,nom,nob)
C        else if(iorder .eq. 9) then
C          call evmono4(rms,rm,nom)
C          call evpoly409(rm,p,nom,nob)
C        else if(iorder .eq. 10) then
C          call evmono4(rms,rm,nom)
C          call evpoly410(rm,p,nom,nob)
C        else if(iorder .eq. 0) then
C          continue
         else
           write(*,*) "Incorrect order of polynomials!"
           stop
         endif
C ABCD system
C      else if(ityp .eq. 5) then
C        if (iorder .eq. 5) then
C          call evmono505(rms,rm,nom)
C          call evpoly505(rm,p,nom,nob)
C        else if(iorder .eq. 6) then
C          call evmono506(rms,rm,nom)
C          call evpoly506(rm,p,nom,nob)
C        else if(iorder .eq. 7) then
C          call evmono507(rms,rm,nom)
C          call evpoly507(rm,p,nom,nob)
C        else if(iorder .eq. 8) then
C          call evmono508(rms,rm,nom)
C          call evpoly508(rm,p,nom,nob)
C        else if(iorder .eq. 9) then
C          call evmono509(rms,rm,nom)
C          call evpoly509(rm,p,nom,nob)
C        else if(iorder .eq. 0) then
C          continue
C        else
C          write(*,*) "Incorrect order of polynomials!"
C          stop
C        endif
      else
        write(*,*) "The fitting program works only for 4 atoms!" 
        stop
      endif

      return

      end subroutine evbas
